#!/usr/bin/env python

from sys import argv

def logmap(x):
	return map(float, x.split())

def cmp(a, b):
	global cbound
	if cbound.has_key(a[1]) and a[0] > cbound[a[1]]:
		if cbound.has_key(b[1]) and b[0] > cbound[b[1]]:
			return 0
		else:
			return 1
	elif cbound.has_key(b[1]) and b[0] > cbound[b[1]]:
		return -1
	else:
		if a[2] > b[2]:
			return 1
		elif a[2] < b[2]:
			return -1
		elif a[0] > b[0]:
			return 1
		elif a[0] < b[0]:
			return -1
		else:
			return 0

def svfmap(l):
	t = l.split()
	return [float(t[0]), float(t[1]), int(t[2]), int(t[3])]

svt = []

texf = open('results.ltx', 'w')
texf.write('\\documentclass[a4paper]{article}\n')
texf.write('\\usepackage{graphics}\n')
texf.write('\\begin{document}\n')
texf.write('\\resizebox{\\linewidth}{!}{\n')
texf.write('\\begin{tabular}{')
for i in range(len(argv)):
	texf.write('c')
texf.write('}\n')
texf.write('\\begin{tabular}{|c|} \\hline\n')
texf.write('Dataset \\\\ \\hline\\hline\n')
texf.write('L1 test result \\\\ \\hline\n')
texf.write('L1 $D^2 e^T\\alpha + \\sum\\xi_i$ \\\\ \\hline\n')
texf.write('L1 $R^2 e^T\\alpha + \\sum\\xi_i$ \\\\ \\hline\n')
texf.write('L1 $(R^2 + 1 / C) e^T\\alpha$ \\\\ \\hline\n')
texf.write('L1 $(R^2 + 1 / C) (\\|w\\|^2 + 2 C \\sum \\xi_i)$ \\\\ \\hline\n')
texf.write('L1 $(R^2 + 0.5 / C) (\\|w\\|^2 + 2 C \\sum \\xi_i)$ \\\\ \\hline\hline\n')
texf.write('L2 test result \\\\ \\hline\n')
texf.write('L2 RM bound \\\\ \\hline\n')
texf.write('L2 $(R^2 + 0.5 / C) \\|\\tilde{w}\\|^2$ \\\\ \\hline\n')
texf.write('L2 $(R^2 + 0.25 / C) \\|\\tilde{w}\\|^2$ \\\\ \\hline\n')
texf.write('\\end{tabular}')

for filename in argv[1:5]:
	sv = []
	cbounds = []
	for i in range(2):
		svf = open(filename + '.L%s.SV.log' % (i + 1), 'r')
		sv.append({})
		cbounds.append({})
		for j in map(svfmap, svf.readlines()):
			sv[i][(j[0], j[1])] = (j[2], j[3])
			if i == 0 and j[2] == j[3] and (cbounds[i].has_key(j[1]) == 0 or cbounds[i][j[1]] > j[0]):
				cbounds[i][j[1]] = j[0]
		svf.close()

	cbound = cbounds[0]
	texf.write(' & \\begin{tabular}{|c|} \\hline\n')
	texf.write('%s \\\\ \\hline\\hline\n' % filename)
	lf = open(filename + '.L1.t.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb0 = {}
	for i in logdb:
		logdb0[(i[0], i[1])] = i[2]
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb[0][2]))
	svt.append(sv[0][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L1.2.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[0][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L1.1.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[0][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L1.5.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[0][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L1.3.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[0][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L1.4.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[0][(logdb[0][0], logdb[0][1])])

	cbound = cbounds[1]
	lf = open(filename + '.L2.t.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb0 = {}
	for i in logdb:
		logdb0[(i[0], i[1])] = i[2]
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb[0][2]))
	svt.append(sv[1][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L2.RM.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[1][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L2.1.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[1][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L2.2.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[1][(logdb[0][0], logdb[0][1])])
	texf.write('\\end{tabular}')
texf.write('\n\\end{tabular}}\n\n')
texf.write('\\resizebox{\\linewidth}{!}{\n')
texf.write('\\begin{tabular}{')
for i in range(len(argv)):
	texf.write('c')
texf.write('}\n')
texf.write('\\begin{tabular}{|c|} \\hline\n')
texf.write('Dataset \\\\ \\hline\\hline\n')
texf.write('L1 test result \\\\ \\hline\n')
texf.write('L1 $D^2 e^T\\alpha + \\sum\\xi_i$ \\\\ \\hline\n')
texf.write('L1 $R^2 e^T\\alpha + \\sum\\xi_i$ \\\\ \\hline\n')
texf.write('L1 $(R^2 + 1 / C) e^T\\alpha$ \\\\ \\hline\n')
texf.write('L1 $(R^2 + 1 / C) (\\|w\\|^2 + 2 C \\sum \\xi_i)$ \\\\ \\hline\n')
texf.write('L1 $(R^2 + 0.5 / C) (\\|w\\|^2 + 2 C \\sum \\xi_i)$ \\\\ \\hline\\hline\n')
texf.write('L2 test result \\\\ \\hline\n')
texf.write('L2 RM bound \\\\ \\hline\n')
texf.write('L2 $(R^2 + 0.5 / C) \\|\\tilde{w}\\|^2$ \\\\ \\hline\n')
texf.write('L2 $(R^2 + 0.25 / C) \\|\\tilde{w}\\|^2$ \\\\ \\hline\n')
texf.write('\\end{tabular}')

for filename in argv[5:]:
	sv = []
	cbounds = []
	for i in range(2):
		svf = open(filename + '.L%s.SV.log' % (i + 1), 'r')
		sv.append({})
		cbounds.append({})
		for j in map(svfmap, svf.readlines()):
			sv[i][(j[0], j[1])] = (j[2], j[3])
			if i == 0 and j[2] == j[3] and (cbounds[i].has_key(j[1]) == 0 or cbounds[i][j[1]] > j[0]):
				cbounds[i][j[1]] = j[0]
		svf.close()

	cbound = cbounds[0]
	texf.write(' & \\begin{tabular}{|c|} \\hline\n')
	texf.write('%s \\\\ \\hline\\hline\n' % filename)
	lf = open(filename + '.L1.t.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb0 = {}
	for i in logdb:
		logdb0[(i[0], i[1])] = i[2]
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb[0][2]))
	svt.append(sv[0][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L1.2.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[0][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L1.1.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[0][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L1.5.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[0][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L1.3.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[0][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L1.4.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[0][(logdb[0][0], logdb[0][1])])

	cbound = cbounds[1]
	lf = open(filename + '.L2.t.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb0 = {}
	for i in logdb:
		logdb0[(i[0], i[1])] = i[2]
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb[0][2]))
	svt.append(sv[1][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L2.RM.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[1][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L2.1.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[1][(logdb[0][0], logdb[0][1])])
	lf = open(filename + '.L2.2.log', 'r')
	logdb = map(logmap, lf.readlines())
	lf.close()
	logdb.sort(cmp)
	texf.write('(%s, %s) %.4f \\\\ \\hline\n' % (logdb[0][0], logdb[0][1], logdb0[(logdb[0][0], logdb[0][1])]))
	svt.append(sv[1][(logdb[0][0], logdb[0][1])])
	texf.write('\\end{tabular}')
texf.write('\n\\end{tabular}}\n\n')


texf.write('(number of SV, number of free SV)\n\n')
texf.write('\\resizebox{\\linewidth}{!}{\n')
texf.write('\\begin{tabular}{')
for i in range(len(argv)):
	texf.write('c')
texf.write('}\n')
texf.write('\\begin{tabular}{|c|} \\hline\n')
texf.write('Dataset \\\\ \\hline\\hline\n')
texf.write('L1 test result \\\\ \\hline\n')
texf.write('L1 $D^2 e^T\\alpha + \\sum\\xi_i$ \\\\ \\hline\n')
texf.write('L1 $R^2 e^T\\alpha + \\sum\\xi_i$ \\\\ \\hline\n')
texf.write('L1 $(R^2 + 1 / C) e^T\\alpha$ \\\\ \\hline\n')
texf.write('L1 $(R^2 + 1 / C) (\\|w\\|^2 + 2 C \\sum \\xi_i)$ \\\\ \\hline\n')
texf.write('L1 $(R^2 + 0.5 / C) (\\|w\\|^2 + 2 C \\sum \\xi_i)$ \\\\ \\hline\\hline\n')
texf.write('L2 test result \\\\ \\hline\n')
texf.write('L2 RM bound \\\\ \\hline\n')
texf.write('L2 $(R^2 + 0.5 / C) \\|\\tilde{w}\\|^2$ \\\\ \\hline\n')
texf.write('L2 $(R^2 + 0.25 / C) \\|\\tilde{w}\\|^2$ \\\\ \\hline\n')
texf.write('\\end{tabular}')
for filename in argv[1:5]:
	texf.write(' & \\begin{tabular}{|c|} \\hline\n')
	texf.write('%s \\\\ \\hline\\hline\n' % filename)
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\\hline\n' % (svt.pop(0),))

	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('\\end{tabular}')
texf.write('\n\\end{tabular}}\n\n')
texf.write('\\resizebox{\\linewidth}{!}{\n')
texf.write('\\begin{tabular}{')
for i in range(len(argv)):
	texf.write('c')
texf.write('}\n')
texf.write('\\begin{tabular}{|c|} \\hline\n')
texf.write('Dataset \\\\ \\hline\\hline\n')
texf.write('L1 test result \\\\ \\hline\n')
texf.write('L1 $D^2 e^T\\alpha + \\sum\\xi_i$ \\\\ \\hline\n')
texf.write('L1 $R^2 e^T\\alpha + \\sum\\xi_i$ \\\\ \\hline\n')
texf.write('L1 $(R^2 + 1 / C) e^T\\alpha$ \\\\ \\hline\n')
texf.write('L1 $(R^2 + 1 / C) (\\|w\\|^2 + 2 C \\sum \\xi_i)$ \\\\ \\hline\n')
texf.write('L1 $(R^2 + 0.5 / C) (\\|w\\|^2 + 2 C \\sum \\xi_i)$ \\\\ \\hline\\hline\n')
texf.write('L2 test result \\\\ \\hline\n')
texf.write('L2 RM bound \\\\ \\hline\n')
texf.write('L2 $(R^2 + 0.5 / C) \\|\\tilde{w}\\|^2$ \\\\ \\hline\n')
texf.write('L2 $(R^2 + 0.25 / C) \\|\\tilde{w}\\|^2$ \\\\ \\hline\n')
texf.write('\\end{tabular}')
for filename in argv[5:]:
	texf.write(' & \\begin{tabular}{|c|} \\hline\n')
	texf.write('%s \\\\ \\hline\\hline\n' % filename)
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\\hline\n' % (svt.pop(0),))

	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('%s \\\\ \\hline\n' % (svt.pop(0),))
	texf.write('\\end{tabular}')
texf.write('\n\\end{tabular}}\n')
texf.write('\\end{document}\n')
texf.close()
